Description

I'd like to implement search feature using REST API, but i noticed that this feature do not respect passed falsy values (booleans nor

numbers). The same behavior can be observed on page.

What i mean is that if i pass 'false' or '0' as value, it's treated like truthy value anyway.

For example, logically, this query:

https://www.redmine.org/projects/redmine/search?q=issue&issues=0&news=0&changesets=0&wiki_pages=1&messages=false&red

mine_plugins=0

should return results of only wiki pages with word 'issue' (because for other parameters i passed falsy values: '0' or 'false'). But those

values are ignored. Even when i pass empty parameter (like '...&messages=&...') it's stil not working properly.

Why is it so big deal?

Well, since on page there is dedicated form for searching, it's not a problem, but when i'm using API eg. in Node.js, it's more logical

and convinient way to pass all search parameters but with bool values (or eventually empty when use 'null' or 'undefined' JS type).

P.S.: Tested on Redmine version 4.1.1

Associated revisions

Revision 20738 - 2021-02-06 06:03 - Go MAEDA

Ignore from search module params sent with empty values (#34615).

Patch by Marius BALTEANU.

Revision 20740 - 2021-02-08 07:22 - Go MAEDA

Merged r20738 from trunk to 4.1-stable (#34615).

Revision 20741 - 2021-02-08 07:24 - Go MAEDA

Merged r20738 from trunk to 4.0-stable (#34615).

History

#1 - 2021-01-24 23:38 - Marius BĂLTEANU

- Status changed from New to Confirmed

#2 - 2021-01-24 23:40 - Marius BĂLTEANU

Thanks Jakub for reporting this issue, I was able to confirm the strange behaviour.

#3 - 2021-01-25 00:10 - Marius BĂLTEANU

I took a look and it seems that some params (for example: all_words, titles_only) already supports passing a "falsy" value, but not by passing 0

(titles_only=0) or false (titles_only=false), but by passing an empty value (titles_only=). In a first phase, I think we can extend this behaviour to module

params as well.

The change is quite small, but I'll post a patch in the following days after I check the tests.

diff --git a/app/controllers/search_controller.rb b/app/controllers/search_controller.rb
index d6bb2dd94..1a4a12fcc 100644

--- a/app/controllers/search_controller.rb

+++ b/app/controllers/search_controller.rb

@@ -63,7 +63,7 @@ class SearchController < ApplicationController

       @object_types = @object_types.select {|o| User.current.allowed_to?("view_#{o}".to_sym, projects_to_sear

ch)}

     end

-    @scope = @object_types.select {|t| params[t]}

+    @scope = @object_types.select {|t| params[t].present?}

     @scope = @object_types if @scope.empty?

     fetcher = Redmine::Search::Fetcher.new(

(END)

 Jakub, please let me know if this cover your needs.

#4 - 2021-01-25 00:14 - Marius BĂLTEANU

- Assignee set to Marius BĂLTEANU

- Target version set to Candidate for next major release

#5 - 2021-01-25 14:01 - Jakub G

Marius thanks for review. Would be great if in the future i could pass "0" and/or "false", but for now it's totally OK to pass empty value as well :) I'll just

map false and 0 to an empty string in my code and that will do the trick :)

#6 - 2021-01-31 22:19 - Marius BĂLTEANU

- File 0001-Ignore-from-search-module-params-sent-with-empty-val.patch added

- Assignee deleted (Marius BĂLTEANU)

Here is the patch with a test.

#7 - 2021-02-04 05:16 - Go MAEDA

- Target version changed from Candidate for next major release to 4.0.8

Setting the target version to 4.0.8.

#8 - 2021-02-06 06:03 - Go MAEDA

- Status changed from Confirmed to Resolved

- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the patch. thank you.

#9 - 2021-02-08 07:24 - Go MAEDA

- Status changed from Resolved to Closed

Committed the patch. Thank you.

Files

0001-Ignore-from-search-module-params-sent-with-empty-val.patch 1.67 KB 2021-01-31 Marius BĂLTEANU
